CREATE TABLE ora_kafka_cluster(
               cluster_name               VARCHAR2(30)  NOT NULL,
               zookeeper_uri              VARCHAR2(4000),
               bootstrap_servers          VARCHAR2(4000) NOT NULL,
               default_directory          VARCHAR2(128)  NOT NULL,
               location_directory         VARCHAR2(128)  NOT NULL,
               cluster_conf_directory     VARCHAR2(128)  NOT NULL,
               cluster_description        VARCHAR2(4000),
               PRIMARY KEY (cluster_name)
               ); 
CREATE TABLE ora_kafka_application(
               cluster_name               VARCHAR2(30)  NOT NULL,
               group_name                 VARCHAR2(30)  NOT NULL,
               topic_name                 VARCHAR2(30)  NOT NULL,
               topic_record_format        VARCHAR2(30)  NOT NULL,
               field_delim                VARCHAR2(130) NOT NULL,
               record_delim               VARCHAR2(130) NOT NULL,
               ref_table_name             VARCHAR2(30),
               num_views                  INTEGER      NOT NULL,
               fetch_max_bytes            INTEGER      NOT NULL,
               num_partitions             INTEGER      NOT NULL,
               view_type                  VARCHAR2(30)  NOT NULL,
               PRIMARY KEY (cluster_name, group_name, topic_name),
               FOREIGN KEY (cluster_name) REFERENCES ora_kafka_cluster(cluster_name)
               );
CREATE TABLE ora_kafka_partition(
               cluster_name               VARCHAR2(30)  NOT NULL,
               group_name                 VARCHAR2(30)  NOT NULL,
               topic_name                 VARCHAR2(30)  NOT NULL,
               partition_id               INTEGER       NOT NULL,
               view_id                    INTEGER       NOT NULL,
               committed_offset           NUMBER(38,0)  NOT NULL,
               view_name                  VARCHAR2(128) NOT NULL,
               start_ts_millis            INTEGER,
               PRIMARY KEY (cluster_name, group_name, topic_name, partition_id),
               FOREIGN KEY (cluster_name, group_name, topic_name) 
               REFERENCES ora_kafka_application(cluster_name, group_name, topic_name)
               );
CREATE TABLE ora_kafka_load_metrics (
               cluster_name               VARCHAR2(30) NOT NULL,
               group_name                 VARCHAR2(30),
               topic_name                 VARCHAR2(30) NOT NULL,
               target_table               VARCHAR2(30)  NOT NULL,
               inserted_rows              NUMBER(19),
               kafka_records              NUMBER(19),
               started_time               TIMESTAMP WITH TIME ZONE,
               finished_time              TIMESTAMP WITH TIME ZONE
);
